| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Private Member Functions | Private Attributes | List of all members
StatusCodeSvc Class Reference

`#include <src/StatusCodeSvc.h>`

Inheritance diagram for StatusCodeSvc:
[legend]
Collaboration diagram for StatusCodeSvc:
[legend]

## Classes
struct | StatCodeDat

## Public Member Functions
StatusCode | initialize () override
StatusCode | reinitialize () override
StatusCode | finalize () override
void | regFnc (const std::string &func, const std::string &lib) override
void | list () const override
bool | suppressCheck () const override
| ~StatusCodeSvc () override=default
Public Member Functions inherited from extends< Service, IStatusCodeSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Member Functions
void | parseFilter (const std::string &str, std::string &fnc, std::string &lib)
void | filterFnc (const std::string &)
void | filterLib (const std::string &)

## Private Attributes
Gaudi::Property< std::vector< std::string > > | m_pFilter {this, "Filter"}
Gaudi::Property< bool > | m_abort {this, "AbortOnError", false}
Gaudi::Property< bool > | m_suppress {this, "SuppressCheck", false}
Gaudi::Property< bool > | m_dict {this, "IgnoreDicts", true}
std::map< std::string, StatCodeDat > | m_dat
std::set< std::string > | m_filterfnc
std::set< std::string > | m_filterlib

## Additional Inherited Members
Public Types inherited from extends< Service, IStatusCodeSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 12 of file StatusCodeSvc.h.

## Constructor & Destructor Documentation

StatusCodeSvc::~StatusCodeSvc | ( |  | ) |
| override default

## Member Function Documentation

void StatusCodeSvc::filterFnc | ( | const std::string & | str | ) |
| private

Definition at line 181 of file StatusCodeSvc.cpp.

181 {
182
183 auto itr = std::find_if(m_dat.begin(),m_dat.end(),
184 [&](const std::pair<std::string,StatCodeDat>& d) {
185 return d.second.fnc == str;
186 });
187 if (itr!=std::end(m_dat)) m_dat.erase(itr);
188
189 }
std::end
T end(T...args)
std::pair
std::find_if
T find_if(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45

void StatusCodeSvc::filterLib | ( | const std::string & | str | ) |
| private

Definition at line 193 of file StatusCodeSvc.cpp.

193 {
194
195 auto itr = std::find_if(m_dat.begin(),m_dat.end(),
196 [&](const std::pair<std::string,StatCodeDat>& d) {
197 return d.second.lib == str;
198 });
199 if (itr!=std::end(m_dat)) m_dat.erase(itr);
200 }
std::end
T end(T...args)
std::pair
std::find_if
T find_if(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45

StatusCode StatusCodeSvc::finalize | ( |  | ) |
| override

Definition at line 61 of file StatusCodeSvc.cpp.

61 {
62
63 if (!m_dat.empty()) {
64
65 info() << "listing all unchecked return codes:" << endmsg;
66
67 list();
68
69 } else {
70
71 if (msgLevel(MSG::DEBUG))
72 debug() << "all StatusCode instances where checked" << endmsg;
73
74 }
75
76 return StatusCode::SUCCESS;
77
78 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:123
MSG::DEBUG
Definition: IMessageSvc.h:18
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:126
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:135
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
StatusCodeSvc::list
void list() const override
Definition: StatusCodeSvc.cpp:145

StatusCode StatusCodeSvc::initialize | ( |  | ) |
| override

Definition at line 19 of file StatusCodeSvc.cpp.

19 {
20
21 StatusCode sc = Service::initialize();
22 if (!sc.isSuccess()) return sc;
23
24 info() << "initialize" << endmsg;
25
26 for (const auto& itr : m_pFilter.value()) {
27 // we need to do this if someone has gotten to regFnc before initialize
28
29 string fnc,lib;
30 parseFilter(itr,fnc,lib);
31
32 if (!fnc.empty()) {
33 filterFnc(fnc);
34 m_filterfnc.insert(fnc);
35 }
36
37 if (!lib.empty()) {
38 filterLib(lib);
39 m_filterlib.insert(lib);
40 }
41
42 }
43
44 return StatusCode::SUCCESS;
45
46 }
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:64
StatusCode::SUCCESS
Definition: StatusCode.h:30
std::string::empty
T empty(T...args)
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:123
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:74
StatusCodeSvc::parseFilter
void parseFilter(const std::string &str, std::string &fnc, std::string &lib)
Definition: StatusCodeSvc.cpp:205
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
StatusCodeSvc::m_filterfnc
std::set< std::string > m_filterfnc
Definition: StatusCodeSvc.h:46
std::set::insert
T insert(T...args)
StatusCodeSvc::filterLib
void filterLib(const std::string &)
Definition: StatusCodeSvc.cpp:193
StatusCodeSvc::m_pFilter
Gaudi::Property< std::vector< std::string > > m_pFilter
Definition: StatusCodeSvc.h:40
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
StatusCodeSvc::filterFnc
void filterFnc(const std::string &)
Definition: StatusCodeSvc.cpp:181
StatusCodeSvc::m_filterlib
std::set< std::string > m_filterlib
Definition: StatusCodeSvc.h:46

void StatusCodeSvc::list | ( |  | ) | const
| override

Definition at line 145 of file StatusCodeSvc.cpp.

145 {
146
147
148
149 std::ostringstream os;
150 os << "Num | Function | Source Library" << endl;
151 os << "----+--------------------------------+-------------------"
152 << "-----------------------" << endl;
153
154 for(const auto& itr : m_dat) {
155 const auto& dat = itr.second;
156
157 os.width(3);
158 os.setf(ios_base::right,ios_base::adjustfield);
159 os << dat.count;
160
161 os << " | ";
162 os.width(30);
163 os.setf(ios_base::left,ios_base::adjustfield);
164 os << dat.fnc;
165
166 os << " | ";
167 os.setf(ios_base::left,ios_base::adjustfield);
168 os << dat.lib;
169
170 os << endl;
171
172 }
173
174 info() << endl << os.str() << endmsg;
175
176 }
std::ostringstream::setf
T setf(T...args)
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:123
std::endl
T endl(T...args)
std::ostringstream
STL class.
std::ostringstream::width
T width(T...args)
std::ostringstream::str
T str(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void StatusCodeSvc::parseFilter | ( | const std::string & | str,
|  | std::string & | fnc,
|  | std::string & | lib
| ) |  |
| private

Definition at line 205 of file StatusCodeSvc.cpp.

205 {
206
207
208 auto loc = str.find("=");
209 if (loc == std::string::npos) {
210 fnc = str;
211 lib = "";
212 } else {
213 string key = str.substr(0,loc);
214 string val = str.substr(loc+1);
215
216 toupper(key);
217
218 if (key == "FCN" || key == "FNC") {
219 fnc = val;
220 lib.clear();
221 } else if (key == "LIB") {
222 fnc.clear();
223 lib = val;
224 } else {
225 fnc.clear();
226 lib.clear();
227
228 warning() << "ignoring unknown token in Filter: " << str
229 << endmsg;
230 }
231 }
232
233 }
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:120
std::string::clear
T clear(T...args)
std::string::find
T find(T...args)
std::string::substr
T substr(T...args)
toupper
void toupper(std::string &s)
Definition: StatusCodeSvc.cpp:10
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

void StatusCodeSvc::regFnc | ( | const std::string & | func,
|  | const std::string & | lib
| ) |  |
| override

Definition at line 85 of file StatusCodeSvc.cpp.

85 {
86
87 if (m_state == Gaudi::StateMachine::OFFLINE ||
88 m_state == Gaudi::StateMachine::CONFIGURED) {
89 return;
90 }
91
92 // A StatusCode instance may be create internally by ROOT dictionaries and,
93 // of course, it's not checked, so here we whitelist a few library names
94 // that are known to produce spurious reports.
95 if (m_dict &&
96 (lib.compare(lib.length()-7, 7, "Dict.so") == 0 ||
97 lib.compare(lib.length()-8, 8, "Cling.so") == 0 ||
98 lib.compare(lib.length()-7, 7, "Core.so") == 0)) {
99 return;
100 }
101 // this appears only with gcc 4.9...
102 if (fnc == "_PyObject_GC_Malloc") return;
103 // GAUDI-1036
104 if (fnc == "PyThread_get_thread_ident") return;
105 if (fnc == "local") return;
106
107 {
108 const string rlib = lib.substr(lib.rfind("/") + 1);
109
110 if (m_filterfnc.find(fnc) != m_filterfnc.end() ||
111 m_filterlib.find(rlib) != m_filterlib.end() ) {
112 return;
113 }
114 }
115
116 if (m_abort) {
117 fatal() << "Unchecked StatusCode in " << fnc << " from lib "
118 << lib << endmsg;
119 abort();
120 }
121
122 string key = fnc + lib;
123
124 auto itr = m_dat.find(key);
125
126 if (itr != m_dat.end()) {
127 itr->second.count += 1;
128 } else {
129
130 const string rlib = lib.substr(lib.rfind("/") + 1);
131
132 StatCodeDat dat;
133 dat.fnc = fnc;
134 dat.lib = rlib;
135 dat.count = 1;
136
137 m_dat[key] = dat;
138 }
139
140 }
Gaudi::StateMachine::CONFIGURED
Definition: StateMachine.h:14
Service::m_state
Gaudi::StateMachine::State m_state
Service state.
Definition: Service.h:191
StatusCodeSvc::m_dict
Gaudi::Property< bool > m_dict
Definition: StatusCodeSvc.h:43
std::string::rfind
T rfind(T...args)
std::set::end
T end(T...args)
StatusCodeSvc::m_filterfnc
std::set< std::string > m_filterfnc
Definition: StatusCodeSvc.h:46
StatusCodeSvc::m_abort
Gaudi::Property< bool > m_abort
Definition: StatusCodeSvc.h:41
std::set::find
T find(T...args)
std::string::length
T length(T...args)
StatusCodeSvc::m_dat
std::map< std::string, StatCodeDat > m_dat
Definition: StatusCodeSvc.h:45
std::string::substr
T substr(T...args)
std::abort
T abort(T...args)
CommonMessagingBase::fatal
MsgStream & fatal() const
shortcut for the method msgStream(MSG::FATAL)
Definition: CommonMessaging.h:111
Gaudi::StateMachine::OFFLINE
Definition: StateMachine.h:13
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
std::string::compare
T compare(T...args)
StatusCodeSvc::m_filterlib
std::set< std::string > m_filterlib
Definition: StatusCodeSvc.h:46

StatusCode StatusCodeSvc::reinitialize | ( |  | ) |
| override

Definition at line 51 of file StatusCodeSvc.cpp.

51 {
52
53 info() << "reinitialize" << endmsg;
54
55 return StatusCode::SUCCESS;
56
57 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:123
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

bool StatusCodeSvc::suppressCheck | ( |  | ) | const
| inline override

Definition at line 22 of file StatusCodeSvc.h.

22 { return m_suppress.value(); }
StatusCodeSvc::m_suppress
Gaudi::Property< bool > m_suppress
Definition: StatusCodeSvc.h:42

## Member Data Documentation

Gaudi::Property<bool> StatusCodeSvc::m_abort {this, "AbortOnError", false}
| private

Definition at line 41 of file StatusCodeSvc.h.

std::map<std::string, StatCodeDat> StatusCodeSvc::m_dat
| private

Definition at line 45 of file StatusCodeSvc.h.

Gaudi::Property<bool> StatusCodeSvc::m_dict {this, "IgnoreDicts", true}
| private

Definition at line 43 of file StatusCodeSvc.h.

std::set<std::string> StatusCodeSvc::m_filterfnc
| private

Definition at line 46 of file StatusCodeSvc.h.

std::set<std::string> StatusCodeSvc::m_filterlib
| private

Definition at line 46 of file StatusCodeSvc.h.

Gaudi::Property<std::vector<std::string> > StatusCodeSvc::m_pFilter {this, "Filter"}
| private

Definition at line 40 of file StatusCodeSvc.h.

Gaudi::Property<bool> StatusCodeSvc::m_suppress {this, "SuppressCheck", false}
| private

Definition at line 42 of file StatusCodeSvc.h.

The documentation for this class was generated from the following files:

- GaudiCommonSvc/src/StatusCodeSvc.h
- GaudiCommonSvc/src/StatusCodeSvc.cpp